Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 2232)
@@ -675,28 +762,64 @@
                               .AND. j == nyn-1 ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 22 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 21 )
-                   ELSEIF ( k > nzb_v_inner(j+1,i) .AND. k > nzb_v_inner(j+2,i)   &
-                                                   .AND. k > nzb_v_inner(j-1,i) ) &
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 21 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),2)  .AND.              &
+                            BTEST(wall_flags_0(k,j+2,i),2)  .AND.              &
+                            BTEST(wall_flags_0(k,j-1,i),2) )                   & 
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 23 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 21 )
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 21 )
                    ENDIF
 !
 !--                v component - z-direction
 !--                WS1 (24), WS3 (25), WS5 (26)
+                   IF ( k == nzb+1 )  THEN
+                      k_mm = nzb
+                   ELSE 
+                      k_mm = k - 2
+                   ENDIF
+                   IF ( k > nzt-1 )  THEN
+                      k_pp = nzt+1
+                   ELSE 
+                      k_pp = k + 2
+                   ENDIF
+                   IF ( k > nzt-2 )  THEN
+                      k_ppp = nzt+1
+                   ELSE 
+                      k_ppp = k + 3
+                   ENDIF  
+                   
                    flag_set = .FALSE.
-                   IF ( k == nzb_v_inner(j,i) + 1 .OR. k == nzt )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 24 )
+                   IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),2)  .AND.            &
+                              BTEST(wall_flags_0(k,j,i),2)    .OR.             &
+                        .NOT. BTEST(wall_flags_0(k_pp,j,i),2) .AND.            &                              
+                              BTEST(wall_flags_0(k,j,i),2)    .OR.             &
+                        k == nzt )                                             &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 24 )
                       flag_set = .TRUE.
-                   ELSEIF ( k == nzb_v_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 25 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),2)    .OR.    &
+                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),2) ) .AND.   & 
+                                  BTEST(wall_flags_0(k-1,j,i),2)  .AND.        &
+                                  BTEST(wall_flags_0(k,j,i),2)    .AND.        &
+                                  BTEST(wall_flags_0(k+1,j,i),2)  .AND.        &
+                                  BTEST(wall_flags_0(k_pp,j,i),2)  .OR.        &
+                                  k == nzt - 1 )                               &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 25 )
                       flag_set = .TRUE.
-                   ELSEIF ( k > nzb_v_inner(j,i) .AND. .NOT. flag_set )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 26 )
+                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),2)  .AND.             &
+                            BTEST(wall_flags_0(k-1,j,i),2)   .AND.             &
+                            BTEST(wall_flags_0(k,j,i),2)     .AND.             &
+                            BTEST(wall_flags_0(k+1,j,i),2)   .AND.             &
+                            BTEST(wall_flags_0(k_pp,j,i),2)  .AND.             &
+                            BTEST(wall_flags_0(k_ppp,j,i),2) .AND.             &
+                            .NOT. flag_set )                                   &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 26 )
                    ENDIF
 
@@ -711,10 +834,10 @@
 !--                Since fluxes are swapped in advec_ws.f90, this is necessary to 
 !--                in order to handle the left/south flux.
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
+                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 27 )
+                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 30 )
 !
 !--                w component - x-direction
 !--                WS1 (27), WS3 (28), WS5 (29)
-                   IF ( k <= nzb_w_inner(j,i+1) .OR.                           &
+                   IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),3) .OR.              &
                             ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )    &
                               .AND. i == nxl   )    .OR.                       &
@@ -722,8 +845,8 @@
                               .AND. i == nxr   ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
-                   ELSEIF ( ( k <= nzb_w_inner(j,i+2) .AND.                    &
-                              k >  nzb_w_inner(j,i+1) ) .OR.                   &
-                              k <= nzb_w_inner(j,i-1)                          &
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 27 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),3)  .AND.      &
+                                    BTEST(wall_flags_0(k,j,i+1),3)  .OR.       &
+                              .NOT. BTEST(wall_flags_0(k,j,i-1),3) )           &
                                                         .OR.                   &
                             ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )    &
@@ -732,20 +855,21 @@
                               .AND. i == nxlu  ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 28 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 28 )
 !   
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 27 )
-                   ELSEIF ( k > nzb_w_inner(j,i+1) .AND. k > nzb_w_inner(j,i+2)   &
-                                                   .AND. k > nzb_w_inner(j,i-1) ) &
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 27 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),3)  .AND.              &
+                            BTEST(wall_flags_0(k,j,i+2),3)  .AND.              &
+                            BTEST(wall_flags_0(k,j,i-1),3) )                   &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i),29 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i),29 )
 !   
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 27 )
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 27 )
                    ENDIF
 !
 !--                w component - y-direction
 !--                WS1 (30), WS3 (31), WS5 (32)
-                   IF ( k <= nzb_w_inner(j+1,i) .OR.                           &
+                   IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),3) .OR.              &
                             ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
                               .AND. j == nys   )    .OR.                       &
@@ -753,8 +877,8 @@
                               .AND. j == nyn   ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
-                   ELSEIF ( ( k <= nzb_w_inner(j+2,i) .AND.                    &
-                              k >  nzb_w_inner(j+1,i) ) .OR.                   &
-                               k <= nzb_w_inner(j-1,i)                         &
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 30 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),3)  .AND.      &
+                                    BTEST(wall_flags_0(k,j+1,i),3)  .OR.       &
+                              .NOT. BTEST(wall_flags_0(k,j-1,i),3) )           &
                                                         .OR.                   &
                             ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
@@ -763,15 +887,16 @@
                               .AND. j == nyn-1 ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 31 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 31 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 30 )
-                   ELSEIF ( k > nzb_w_inner(j+1,i) .AND. k > nzb_w_inner(j+2,i)   &
-                                                   .AND. k > nzb_w_inner(j-1,i) ) &
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 30 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),3)  .AND.              &
+                            BTEST(wall_flags_0(k,j+2,i),3)  .AND.              &
+                            BTEST(wall_flags_0(k,j-1,i),3) )                   &
                    THEN
-                      wall_flags_00(k,j,i) = IBSET( wall_flags_00(k,j,i), 0 )
+                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 0 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 30 )
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 30 )
                    ENDIF
 !
@@ -779,6 +904,29 @@
 !--                WS1 (33), WS3 (34), WS5 (35)
                    flag_set = .FALSE.
-                   IF ( k == nzb_w_inner(j,i) .OR. k == nzb_w_inner(j,i) + 1   &
-                                              .OR. k == nzt )  THEN
+                   IF ( k == nzb+1 )  THEN
+                      k_mm = nzb
+                   ELSE
+                      k_mm = k - 2
+                   ENDIF
+                   IF ( k > nzt-1 )  THEN
+                      k_pp = nzt+1
+                   ELSE 
+                      k_pp = k + 2
+                   ENDIF
+                   IF ( k > nzt-2 )  THEN
+                      k_ppp = nzt+1
+                   ELSE 
+                      k_ppp = k + 3
+                   ENDIF  
+                   
+                   IF ( ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)  .AND.          &
+                          .NOT. BTEST(wall_flags_0(k,j,i),3)    .AND.          &
+                                BTEST(wall_flags_0(k+1,j,i),3) )  .OR.         &
+                        ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)  .AND.          &
+                                BTEST(wall_flags_0(k,j,i),3) )  .OR.           &
+                        ( .NOT. BTEST(wall_flags_0(k+1,j,i),3)  .AND.          &
+                                BTEST(wall_flags_0(k,j,i),3) )  .OR.           &        
+                        k == nzt )                                             &
+                   THEN
 !
 !--                   Please note, at k == nzb_w_inner(j,i) a flag is explictely
@@ -787,11 +935,24 @@
 !--                   because flux_t(nzb_w_inner(j,i)) is used for the tendency
 !--                   at k == nzb_w_inner(j,i)+1.
-                      wall_flags_00(k,j,i) = IBSET( wall_flags_00(k,j,i), 1 )
+                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 1 )
                       flag_set = .TRUE.
-                   ELSEIF ( k == nzb_w_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
-                      wall_flags_00(k,j,i) = IBSET( wall_flags_00(k,j,i), 2 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),3)     .OR.   &
+                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),3) ) .AND.   &
+                                    BTEST(wall_flags_0(k-1,j,i),3)  .AND.      &
+                                    BTEST(wall_flags_0(k,j,i),3)    .AND.      &
+                                    BTEST(wall_flags_0(k+1,j,i),3)  .OR.       &
+                            k == nzt - 1 )                                     &
+                   THEN
+                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 2 )
                       flag_set = .TRUE.
-                   ELSEIF ( k > nzb_w_inner(j,i) .AND. .NOT. flag_set )  THEN
-                      wall_flags_00(k,j,i) = IBSET( wall_flags_00(k,j,i), 3 )
+                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),3)  .AND.             &
+                            BTEST(wall_flags_0(k-1,j,i),3)   .AND.             &
+                            BTEST(wall_flags_0(k,j,i),3)     .AND.             &
+                            BTEST(wall_flags_0(k+1,j,i),3)   .AND.             &
+                            BTEST(wall_flags_0(k_pp,j,i),3)  .AND.             &
+                            BTEST(wall_flags_0(k_ppp,j,i),3) .AND.             &
+                            .NOT. flag_set )                                   &
+                   THEN
+                      advc_flags_2(k,j,i) = IBSET( advc_flags_2(k,j,i), 3 )
                    ENDIF
 
@@ -809,27 +970,27 @@
 !
 !--       Exchange ghost points for advection flags
-          CALL exchange_horiz_int( wall_flags_0,  nbgp )
-          CALL exchange_horiz_int( wall_flags_00, nbgp )
+          CALL exchange_horiz_int( advc_flags_1, nbgp )
+          CALL exchange_horiz_int( advc_flags_2, nbgp )
 !
 !--       Set boundary flags at inflow and outflow boundary in case of 
 !--       non-cyclic boundary conditions.
          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
-             wall_flags_0(:,:,nxl-1)  = wall_flags_0(:,:,nxl)
-             wall_flags_00(:,:,nxl-1) = wall_flags_00(:,:,nxl)
+             advc_flags_1(:,:,nxl-1) = advc_flags_1(:,:,nxl)
+             advc_flags_2(:,:,nxl-1) = advc_flags_2(:,:,nxl)
          ENDIF
 
          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
-            wall_flags_0(:,:,nxr+1)  = wall_flags_0(:,:,nxr)
-            wall_flags_00(:,:,nxr+1) = wall_flags_00(:,:,nxr)
+            advc_flags_1(:,:,nxr+1) = advc_flags_1(:,:,nxr)
+            advc_flags_2(:,:,nxr+1) = advc_flags_2(:,:,nxr)
           ENDIF
 
           IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
-             wall_flags_0(:,nyn+1,:)  = wall_flags_0(:,nyn,:)
-             wall_flags_00(:,nyn+1,:) = wall_flags_00(:,nyn,:)
+             advc_flags_1(:,nyn+1,:) = advc_flags_1(:,nyn,:)
+             advc_flags_2(:,nyn+1,:) = advc_flags_2(:,nyn,:)
           ENDIF
 
           IF ( inflow_s .OR. outflow_s  .OR. nest_bound_s )  THEN
-             wall_flags_0(:,nys-1,:)  = wall_flags_0(:,nys,:)
-             wall_flags_00(:,nys-1,:) = wall_flags_00(:,nys,:)
+             advc_flags_1(:,nys-1,:) = advc_flags_1(:,nys,:)
+             advc_flags_2(:,nys-1,:) = advc_flags_2(:,nys,:)
           ENDIF
   
@@ -910,5 +1071,5 @@
        USE indices,                                                            &
            ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_max,    &
-                  nzt, wall_flags_0
+                  nzt, advc_flags_1
 
        USE kinds
@@ -976,7 +1137,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit5 = IBITS(wall_flags_0(k,j-1,i),5,1)
-             ibit4 = IBITS(wall_flags_0(k,j-1,i),4,1)
-             ibit3 = IBITS(wall_flags_0(k,j-1,i),3,1)
+             ibit5 = IBITS(advc_flags_1(k,j-1,i),5,1)
+             ibit4 = IBITS(advc_flags_1(k,j-1,i),4,1)
+             ibit3 = IBITS(advc_flags_1(k,j-1,i),3,1)
 
              v_comp                  = v(k,j,i) - v_gtrans
@@ -1037,7 +1198,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit2 = IBITS(wall_flags_0(k,j,i-1),2,1)
-             ibit1 = IBITS(wall_flags_0(k,j,i-1),1,1)
-             ibit0 = IBITS(wall_flags_0(k,j,i-1),0,1)
+             ibit2 = IBITS(advc_flags_1(k,j,i-1),2,1)
+             ibit1 = IBITS(advc_flags_1(k,j,i-1),1,1)
+             ibit0 = IBITS(advc_flags_1(k,j,i-1),0,1)
 
              u_comp                     = u(k,j,i) - u_gtrans
@@ -1106,7 +1267,7 @@
 !--       flux at the end. 
 
-          ibit2 = IBITS(wall_flags_0(k,j,i),2,1)
-          ibit1 = IBITS(wall_flags_0(k,j,i),1,1)
-          ibit0 = IBITS(wall_flags_0(k,j,i),0,1)
+          ibit2 = IBITS(advc_flags_1(k,j,i),2,1)
+          ibit1 = IBITS(advc_flags_1(k,j,i),1,1)
+          ibit0 = IBITS(advc_flags_1(k,j,i),0,1)
 
           u_comp    = u(k,j,i+1) - u_gtrans
@@ -1141,7 +1302,7 @@
                                        )
 
-          ibit5 = IBITS(wall_flags_0(k,j,i),5,1)
-          ibit4 = IBITS(wall_flags_0(k,j,i),4,1)
-          ibit3 = IBITS(wall_flags_0(k,j,i),3,1)
+          ibit5 = IBITS(advc_flags_1(k,j,i),5,1)
+          ibit4 = IBITS(advc_flags_1(k,j,i),4,1)
+          ibit3 = IBITS(advc_flags_1(k,j,i),3,1)
 
           v_comp    = v(k,j+1,i) - v_gtrans
@@ -1178,7 +1339,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit8 = IBITS(wall_flags_0(k,j,i),8,1)
-          ibit7 = IBITS(wall_flags_0(k,j,i),7,1)
-          ibit6 = IBITS(wall_flags_0(k,j,i),6,1)
+          ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
+          ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
+          ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
 
           k_ppp = k + 3 * ibit8
@@ -1220,13 +1381,13 @@
 !--       by a not sufficient reduction of divergences near topography. 
           div         =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )             &
-                          - u(k,j,i)   * ( IBITS(wall_flags_0(k,j,i-1),0,1)    &
-                                         + IBITS(wall_flags_0(k,j,i-1),1,1)    &
-                                         + IBITS(wall_flags_0(k,j,i-1),2,1)    &
+                          - u(k,j,i)   * ( IBITS(advc_flags_1(k,j,i-1),0,1)    &
+                                         + IBITS(advc_flags_1(k,j,i-1),1,1)    &
+                                         + IBITS(advc_flags_1(k,j,i-1),2,1)    &
                                          )                                     &
                           ) * rho_air(k) * ddx                                 &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
-                          - v(k,j,i)   * ( IBITS(wall_flags_0(k,j-1,i),3,1)    &
-                                         + IBITS(wall_flags_0(k,j-1,i),4,1)    &
-                                         + IBITS(wall_flags_0(k,j-1,i),5,1)    &
+                          - v(k,j,i)   * ( IBITS(advc_flags_1(k,j-1,i),3,1)    &
+                                         + IBITS(advc_flags_1(k,j-1,i),4,1)    &
+                                         + IBITS(advc_flags_1(k,j-1,i),5,1)    &
                                          )                                     &
                           ) * rho_air(k) * ddy                                 &
@@ -1234,7 +1395,7 @@
                                          ( ibit6 + ibit7 + ibit8 )             &
                           - w(k-1,j,i) * rho_air_zw(k-1) *                     &
-                                         ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
-                                         + IBITS(wall_flags_0(k-1,j,i),7,1)    &
-                                         + IBITS(wall_flags_0(k-1,j,i),8,1)    &
+                                         ( IBITS(advc_flags_1(k-1,j,i),6,1)    &
+                                         + IBITS(advc_flags_1(k-1,j,i),7,1)    &
+                                         + IBITS(advc_flags_1(k-1,j,i),8,1)    &
                                          )                                     &      
                           ) * ddzw(k)
@@ -1287,7 +1448,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit8 = IBITS(wall_flags_0(k,j,i),8,1)
-          ibit7 = IBITS(wall_flags_0(k,j,i),7,1)
-          ibit6 = IBITS(wall_flags_0(k,j,i),6,1)
+          ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
+          ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
+          ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
 
           k_ppp = k + 3 * ibit8
@@ -1450,5 +1611,5 @@
 
        USE indices,                                                           &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, advc_flags_1
 
        USE kinds
@@ -1502,7 +1663,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit14 = IBITS(wall_flags_0(k,j-1,i),14,1)
-             ibit13 = IBITS(wall_flags_0(k,j-1,i),13,1)
-             ibit12 = IBITS(wall_flags_0(k,j-1,i),12,1)
+             ibit14 = IBITS(advc_flags_1(k,j-1,i),14,1)
+             ibit13 = IBITS(advc_flags_1(k,j-1,i),13,1)
+             ibit12 = IBITS(advc_flags_1(k,j-1,i),12,1)
 
              v_comp      = v(k,j,i) + v(k,j,i-1) - gv
@@ -1560,7 +1721,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit11 = IBITS(wall_flags_0(k,j,i-1),11,1)
-             ibit10 = IBITS(wall_flags_0(k,j,i-1),10,1)
-             ibit9  = IBITS(wall_flags_0(k,j,i-1),9,1)
+             ibit11 = IBITS(advc_flags_1(k,j,i-1),11,1)
+             ibit10 = IBITS(advc_flags_1(k,j,i-1),10,1)
+             ibit9  = IBITS(advc_flags_1(k,j,i-1),9,1)
 
              u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
@@ -1622,7 +1783,7 @@
        DO  k = nzb+1, nzb_max
 
-          ibit11 = IBITS(wall_flags_0(k,j,i),11,1)
-          ibit10 = IBITS(wall_flags_0(k,j,i),10,1)
-          ibit9  = IBITS(wall_flags_0(k,j,i),9,1)
+          ibit11 = IBITS(advc_flags_1(k,j,i),11,1)
+          ibit10 = IBITS(advc_flags_1(k,j,i),10,1)
+          ibit9  = IBITS(advc_flags_1(k,j,i),9,1)
 
           u_comp(k) = u(k,j,i+1) + u(k,j,i)
@@ -1657,7 +1818,7 @@
                                                 )
 
-          ibit14 = IBITS(wall_flags_0(k,j,i),14,1)
-          ibit13 = IBITS(wall_flags_0(k,j,i),13,1)
-          ibit12 = IBITS(wall_flags_0(k,j,i),12,1)
+          ibit14 = IBITS(advc_flags_1(k,j,i),14,1)
+          ibit13 = IBITS(advc_flags_1(k,j,i),13,1)
+          ibit12 = IBITS(advc_flags_1(k,j,i),12,1)
 
           v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
@@ -1694,7 +1855,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit17 = IBITS(wall_flags_0(k,j,i),17,1)
-          ibit16 = IBITS(wall_flags_0(k,j,i),16,1)
-          ibit15 = IBITS(wall_flags_0(k,j,i),15,1)
+          ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
+          ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
+          ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
 
           k_ppp = k + 3 * ibit17
@@ -1738,21 +1899,21 @@
           div = ( ( u_comp(k)       * ( ibit9 + ibit10 + ibit11 )             &
                 - ( u(k,j,i)   + u(k,j,i-1)   )                               &
-                                    * ( IBITS(wall_flags_0(k,j,i-1),9,1)      &
-                                      + IBITS(wall_flags_0(k,j,i-1),10,1)     &
-                                      + IBITS(wall_flags_0(k,j,i-1),11,1)     &
+                                    * ( IBITS(advc_flags_1(k,j,i-1),9,1)      &
+                                      + IBITS(advc_flags_1(k,j,i-1),10,1)     &
+                                      + IBITS(advc_flags_1(k,j,i-1),11,1)     &
                                       )                                       &
                   ) * rho_air(k) * ddx                                        &
                +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
-                                    * ( IBITS(wall_flags_0(k,j-1,i),12,1)     &
-                                      + IBITS(wall_flags_0(k,j-1,i),13,1)     &
-                                      + IBITS(wall_flags_0(k,j-1,i),14,1)     &
+                                    * ( IBITS(advc_flags_1(k,j-1,i),12,1)     &
+                                      + IBITS(advc_flags_1(k,j-1,i),13,1)     &
+                                      + IBITS(advc_flags_1(k,j-1,i),14,1)     &
                                       )                                       &
                   ) * rho_air(k) * ddy                                        &
                +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
                 - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
-                                    * ( IBITS(wall_flags_0(k-1,j,i),15,1)     &
-                                      + IBITS(wall_flags_0(k-1,j,i),16,1)     &
-                                      + IBITS(wall_flags_0(k-1,j,i),17,1)     &
+                                    * ( IBITS(advc_flags_1(k-1,j,i),15,1)     &
+                                      + IBITS(advc_flags_1(k-1,j,i),16,1)     &
+                                      + IBITS(advc_flags_1(k-1,j,i),17,1)     &
                                       )                                       &  
                   ) * ddzw(k)   &
@@ -1823,7 +1984,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit17 = IBITS(wall_flags_0(k,j,i),17,1)
-          ibit16 = IBITS(wall_flags_0(k,j,i),16,1)
-          ibit15 = IBITS(wall_flags_0(k,j,i),15,1)
+          ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
+          ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
+          ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
 
           k_ppp = k + 3 * ibit17
@@ -1942,5 +2103,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_max, nzt, wall_flags_0
+           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_max, nzt, advc_flags_1
 
        USE kinds
@@ -1995,7 +2156,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit20 = IBITS(wall_flags_0(k,j,i-1),20,1)
-             ibit19 = IBITS(wall_flags_0(k,j,i-1),19,1)
-             ibit18 = IBITS(wall_flags_0(k,j,i-1),18,1)
+             ibit20 = IBITS(advc_flags_1(k,j,i-1),20,1)
+             ibit19 = IBITS(advc_flags_1(k,j,i-1),19,1)
+             ibit18 = IBITS(advc_flags_1(k,j,i-1),18,1)
 
              u_comp           = u(k,j-1,i) + u(k,j,i) - gu
@@ -2053,7 +2214,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit23 = IBITS(wall_flags_0(k,j-1,i),23,1)
-             ibit22 = IBITS(wall_flags_0(k,j-1,i),22,1)
-             ibit21 = IBITS(wall_flags_0(k,j-1,i),21,1)
+             ibit23 = IBITS(advc_flags_1(k,j-1,i),23,1)
+             ibit22 = IBITS(advc_flags_1(k,j-1,i),22,1)
+             ibit21 = IBITS(advc_flags_1(k,j-1,i),21,1)
 
              v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
@@ -2115,7 +2276,7 @@
        DO  k = nzb+1, nzb_max
 
-          ibit20 = IBITS(wall_flags_0(k,j,i),20,1)
-          ibit19 = IBITS(wall_flags_0(k,j,i),19,1)
-          ibit18 = IBITS(wall_flags_0(k,j,i),18,1)
+          ibit20 = IBITS(advc_flags_1(k,j,i),20,1)
+          ibit19 = IBITS(advc_flags_1(k,j,i),19,1)
+          ibit18 = IBITS(advc_flags_1(k,j,i),18,1)
  
           u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
@@ -2150,7 +2311,7 @@
                                         )
 
-          ibit23 = IBITS(wall_flags_0(k,j,i),23,1)
-          ibit22 = IBITS(wall_flags_0(k,j,i),22,1)
-          ibit21 = IBITS(wall_flags_0(k,j,i),21,1)
+          ibit23 = IBITS(advc_flags_1(k,j,i),23,1)
+          ibit22 = IBITS(advc_flags_1(k,j,i),22,1)
+          ibit21 = IBITS(advc_flags_1(k,j,i),21,1)
 
 
@@ -2188,7 +2349,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit26 = IBITS(wall_flags_0(k,j,i),26,1)
-          ibit25 = IBITS(wall_flags_0(k,j,i),25,1)
-          ibit24 = IBITS(wall_flags_0(k,j,i),24,1)
+          ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
+          ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
+          ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
 
           k_ppp = k + 3 * ibit26
@@ -2233,7 +2394,7 @@
                                        * ( ibit18 + ibit19 + ibit20 )         &
                   - ( u(k,j-1,i) + u(k,j,i) )                                 &
-                                       * ( IBITS(wall_flags_0(k,j,i-1),18,1)  &
-                                         + IBITS(wall_flags_0(k,j,i-1),19,1)  &
-                                         + IBITS(wall_flags_0(k,j,i-1),20,1)  &
+                                       * ( IBITS(advc_flags_1(k,j,i-1),18,1)  &
+                                         + IBITS(advc_flags_1(k,j,i-1),19,1)  &
+                                         + IBITS(advc_flags_1(k,j,i-1),20,1)  &
                                          )                                    &
                   ) * rho_air(k) * ddx                                        &
@@ -2241,14 +2402,14 @@
                                        * ( ibit21 + ibit22 + ibit23 )         &
                 - ( v(k,j,i)     + v(k,j-1,i) )                               &
-                                       * ( IBITS(wall_flags_0(k,j-1,i),21,1)  &
-                                         + IBITS(wall_flags_0(k,j-1,i),22,1)  &
-                                         + IBITS(wall_flags_0(k,j-1,i),23,1)  &
+                                       * ( IBITS(advc_flags_1(k,j-1,i),21,1)  &
+                                         + IBITS(advc_flags_1(k,j-1,i),22,1)  &
+                                         + IBITS(advc_flags_1(k,j-1,i),23,1)  &
                                          )                                    &
                   ) * rho_air(k) * ddy                                        &
                +  ( w_comp * rho_air_zw(k) * ( ibit24 + ibit25 + ibit26 )     &
                 - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)             &
-                                       * ( IBITS(wall_flags_0(k-1,j,i),24,1)  &
-                                         + IBITS(wall_flags_0(k-1,j,i),25,1)  &
-                                         + IBITS(wall_flags_0(k-1,j,i),26,1)  &
+                                       * ( IBITS(advc_flags_1(k-1,j,i),24,1)  &
+                                         + IBITS(advc_flags_1(k-1,j,i),25,1)  &
+                                         + IBITS(advc_flags_1(k-1,j,i),26,1)  &
                                          )                                    &
                    ) * ddzw(k)   &
@@ -2324,7 +2485,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit26 = IBITS(wall_flags_0(k,j,i),26,1)
-          ibit25 = IBITS(wall_flags_0(k,j,i),25,1)
-          ibit24 = IBITS(wall_flags_0(k,j,i),24,1)
+          ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
+          ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
+          ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
 
           k_ppp = k + 3 * ibit26
